
function Watch4_OnLoad(self)
   print("Watch4 (Beta) loaded")
   self:RegisterEvent("ADDON_LOADED")
   self:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")
   self:RegisterEvent("RAID_INSTANCE_WELCOME")
end

function Watch4_OnEvent(self, event, ...)
   -- Show the window
   -- ShowUIPanel(Watch4Frame)
   -- print ("Event: " .. event)
   if event == "ADDON_LOADED" then
      -- print("Watch4 (Beta) loaded")
   end
   if event == "RAID_INSTANCE_WELCOME" then
      Watch4_OnRaidEnter(...)
   end
   if event == "COMBAT_LOG_EVENT_UNFILTERED" then
      Watch4_OnCombatEvent(...)
   end
end

function Watch4_OnRaidEnter(...)
   local name, ttl = ...
end

function Watch4_OnClearAll()

WatchPOFCheckButton:SetChecked(false)
WatchRaiseDeadCheckButton:SetChecked(false)
WatchVBCheckButton:SetChecked(false)
WatchIBFCheckButton:SetChecked(false)
WatchAMSCheckButton:SetChecked(false)
WatchDRWCheckButton:SetChecked(false)
WatchTranquilityCheckButton:SetChecked(false)
WatchTreeCheckButton:SetChecked(false)
WatchInnervateCheckButton:SetChecked(false)
WatchRebirthCheckButton:SetChecked(false)
WatchMDCheckButton:SetChecked(false)
WatchRFCheckButton:SetChecked(false)
WatchReadinessCheckButton:SetChecked(false)
WatchCOTWCheckButton:SetChecked(false)
WatchDeterrenceCheckButton:SetChecked(false)
WatchPackCheckButton:SetChecked(false)
WatchTWCheckButton:SetChecked(false)
WatchMageWardCheckButton:SetChecked(false)
WatchIceBlockCheckButton:SetChecked(false)
WatchDGCheckButton:SetChecked(false)
WatchDSCheckButton:SetChecked(false)
WatchGotAKCheckButton:SetChecked(false)
WatchLoHCheckButton:SetChecked(false)
WatchHoPCheckButton:SetChecked(false)
WatchADCheckButton:SetChecked(false)
WatchHSCheckButton:SetChecked(false)
WatchGSCheckButton:SetChecked(false)
WatchPSCheckButton:SetChecked(false)
WatchHoHCheckButton:SetChecked(false)
WatchPICheckButton:SetChecked(false)
WatchLoFCheckButton:SetChecked(false)
WatchToTCheckButton:SetChecked(false)
WatchCoSCheckButton:SetChecked(false)
WatchHeroCheckButton:SetChecked(false)
WatchMTTCheckButton:SetChecked(false)
WatchSLTCheckButton:SetChecked(false)
WatchDemonSoulCheckButton:SetChecked(false)
WatchNetherwardCheckButton:SetChecked(false)
WatchDoomguardCheckButton:SetChecked(false)
WatchInfernalCheckButton:SetChecked(false)
WatchRCCheckButton:SetChecked(false)
WatchSWCheckButton:SetChecked(false)
WatchLSCheckButton:SetChecked(false)

end

function Watch4_OnCheckAll()

WatchPOFCheckButton:SetChecked(true)
WatchRaiseDeadCheckButton:SetChecked(true)
WatchVBCheckButton:SetChecked(true)
WatchIBFCheckButton:SetChecked(true)
WatchAMSCheckButton:SetChecked(true)
WatchDRWCheckButton:SetChecked(true)
WatchTranquilityCheckButton:SetChecked(true)
WatchTreeCheckButton:SetChecked(true)
WatchInnervateCheckButton:SetChecked(true)
WatchRebirthCheckButton:SetChecked(true)
WatchMDCheckButton:SetChecked(true)
WatchRFCheckButton:SetChecked(true)
WatchReadinessCheckButton:SetChecked(true)
WatchCOTWCheckButton:SetChecked(true)
WatchDeterrenceCheckButton:SetChecked(true)
WatchPackCheckButton:SetChecked(true)
WatchTWCheckButton:SetChecked(true)
WatchMageWardCheckButton:SetChecked(true)
WatchIceBlockCheckButton:SetChecked(true)
WatchDGCheckButton:SetChecked(true)
WatchDSCheckButton:SetChecked(true)
WatchGotAKCheckButton:SetChecked(true)
WatchLoHCheckButton:SetChecked(true)
WatchHoPCheckButton:SetChecked(true)
WatchADCheckButton:SetChecked(true)
WatchHSCheckButton:SetChecked(true)
WatchGSCheckButton:SetChecked(true)
WatchPSCheckButton:SetChecked(true)
WatchHoHCheckButton:SetChecked(true)
WatchPICheckButton:SetChecked(true)
WatchLoFCheckButton:SetChecked(true)
WatchToTCheckButton:SetChecked(true)
WatchCoSCheckButton:SetChecked(true)
WatchHeroCheckButton:SetChecked(true)
WatchMTTCheckButton:SetChecked(true)
WatchSLTCheckButton:SetChecked(true)
WatchDemonSoulCheckButton:SetChecked(true)
WatchNetherwardCheckButton:SetChecked(true)
WatchDoomguardCheckButton:SetChecked(true)
WatchInfernalCheckButton:SetChecked(true)
WatchRCCheckButton:SetChecked(true)
WatchSWCheckButton:SetChecked(true)
WatchLSCheckButton:SetChecked(true)

end

function Watch4_OnCombatEvent(...)
   -- Get all arguments.
   local time, type, arg3, arg4, source, arg6, arg7, arg8, target, arg10, arg11, arg12, ability, arg14, arg15 = ...
   local msg
   local found = false
   if (type == "SPELL_CAST_SUCCESS") then

      -- Druid --
      if (WatchTranquilityCheckButton:GetChecked() and ability == "Tranquility") then
         msg = source .. " casts " .. ability
      elseif (WatchInnervateCheckButton:GetChecked() and ability == "Innervate") then
         msg = source .. " casts " .. ability
         if (target ~= nil) then
            msg = msg .. " on " .. target
         end
      elseif (WatchRebirthCheckButton:GetChecked() and ability == "Rebirth") then
         msg = source .. " casts " .. ability
         if (target ~= nil) then
            msg = msg .. " on " .. target
         end

      -- Hunter --
      elseif (WatchMDCheckButton:GetChecked() and ability == "Misdirection") then
         msg = source .. " casts " .. ability
         if (target ~= nil) then
            msg = msg .. " on " .. target
         end
      elseif (WatchReadinessCheckButton:GetChecked() and ability == "Readiness") then
         msg = source .. " casts " .. ability
      elseif (WatchPackCheckButton:GetChecked() and ability == "Aspect of the Pack") then
         msg = source .. " casts " .. ability

      -- Mage --
      elseif (WatchTWCheckButton:GetChecked() and ability == "Time Warp") then
         msg = source .. " casts " .. ability
      elseif (WatchMageWardCheckButton:GetChecked() and ability == "Mage Ward") then
         msg = source .. " casts " .. ability
      elseif (WatchIceBlockCheckButton:GetChecked() and ability == "Ice Block") then
         msg = source .. " casts " .. ability

      -- Paladin --
      elseif (WatchDGCheckButton:GetChecked() and ability == "Divine Guardian") then
         msg = source .. " casts " .. ability
      elseif (WatchDPCheckButton:GetChecked() and ability == "Divine Protection") then
         msg = source .. " casts " .. ability
      elseif (WatchDSCheckButton:GetChecked() and ability == "Divine Shield") then
         msg = source .. " casts " .. ability
      elseif (WatchGotAKCheckButton:GetChecked() and ability == "Guardian of Ancient Kings") then
         msg = source .. " casts " .. ability
      elseif (WatchADCheckButton:GetChecked() and ability == "Ardent Defender") then
         msg = source .. " casts " .. ability
      elseif (WatchLoHCheckButton:GetChecked() and ability == "Lay on Hands") then
         msg = source .. " casts " .. ability
         if (target ~= nil) then
            msg = msg .. " on " .. target
         end
      elseif (WatchHoPCheckButton:GetChecked() and ability == "Hand of Protection") then
         msg = source .. " casts " .. ability
         if (target ~= nil) then
            msg = msg .. " on " .. target
         end
      elseif (WatchHSCheckButton:GetChecked() and ability == "Holy Shield") then
         msg = source .. " casts " .. ability

      -- Priest --
      elseif (WatchGSCheckButton:GetChecked() and ability == "Guardian Spirit") then
         msg = source .. " casts " .. ability
         if (target ~= nil) then
            msg = msg .. " on " .. target
         end
      elseif (WatchPSCheckButton:GetChecked() and ability == "Pain Suppression") then
         msg = source .. " casts " .. ability
         if (target ~= nil) then
            msg = msg .. " on " .. target
         end
      elseif (WatchHoHCheckButton:GetChecked() and ability == "Hymn of Hope") then
         msg = source .. " casts " .. ability
      elseif (WatchPICheckButton:GetChecked() and ability == "Power Infusion") then
         msg = source .. " casts " .. ability
         if (target ~= nil) then
            msg = msg .. " on " .. target
         end
      elseif (WatchLoFCheckButton:GetChecked() and ability == "Leap of Faith") then
         msg = source .. " casts " .. ability
         if (target ~= nil) then
            msg = msg .. " on " .. target
         end

      -- Rogue --
      elseif (WatchToTCheckButton:GetChecked() and ability == "Tricks of the Trade") then
         msg = source .. " casts " .. ability
         if (target ~= nil) then
            msg = msg .. " on " .. target
         end
      elseif (WatchCoSCheckButton:GetChecked() and ability == "Cloak of Shadows") then
         msg = source .. " casts " .. ability

      -- Shaman --
      elseif (WatchHeroCheckButton:GetChecked() and ability == "Herosim") then
         msg = source .. " casts " .. ability
      elseif (WatchMTTCheckButton:GetChecked() and ability == "Mana Tide Totem") then
         msg = source .. " casts " .. ability
      elseif (WatchSLTCheckButton:GetChecked() and ability == "Spirit Link Totem") then
         msg = source .. " casts " .. ability

      -- Warlock --
      elseif (WatchDemonSoulCheckButton:GetChecked() and ability == "Demon Soul") then
         msg = source .. " casts " .. ability
      elseif (WatchNetherwardCheckButton:GetChecked() and ability == "Nether Ward") then
         msg = source .. " casts " .. ability
      elseif (WatchDoomguardCheckButton:GetChecked() and ability == "Summon Doomguard") then
         msg = source .. " casts " .. ability
      elseif (WatchInfernalCheckButton:GetChecked() and ability == "Summon Infernal") then
         msg = source .. " casts " .. ability

      -- Warrior --
      elseif (WatchRCCheckButton:GetChecked() and ability == "Rallying Cry") then
         msg = source .. " casts " .. ability
      elseif (WatchSWCheckButton:GetChecked() and ability == "Shield Wall") then
         msg = source .. " casts " .. ability
      elseif (WatchLSCheckButton:GetChecked() and ability == "Last Stand") then
         msg = source .. " casts " .. ability

      end

   elseif (type == "SPELL_AURA_APPLIED") then
      -- DK --
      if (WatchPOFCheckButton:GetChecked() and ability == "Pillar of Frost") then
         msg = source .. " casts " .. ability
      elseif(WatchVBCheckButton:GetChecked() and ability == "Vampiric Blood") then
         msg = source .. " casts " .. ability
      elseif (WatchIBFCheckButton:GetChecked() and ability == "Icebound Fortitude") then
         msg = source .. " casts " .. ability
      elseif (WatchAMSCheckButton:GetChecked() and ability == "Anti-Magic Shell") then
         msg = source .. " casts " .. ability
      elseif (WatchDRWCheckButton:GetChecked() and ability == "Dancing Rune Weapon") then
         msg =  source .. " casts " .. ability

      -- Druid --
      elseif (WatchTreeCheckButton:GetChecked() and ability == "Tree of Life") then
         msg = source .. " casts " .. ability

      -- Hunter --
      elseif (WatchRFCheckButton:GetChecked() and ability == "Rapid Fire") then
         msg = source .. " casts " .. ability
      
      elseif (WatchCOTWCheckButton:GetChecked() and ability == "Call of the Wild") then
         msg = source .. " casts " .. ability
      elseif (WatchDeterrenceCheckButton:GetChecked() and ability == "Deterrence") then
         msg = source .. " casts " .. ability
      end

   elseif (type == "SPELL_AURA_REMOVED") then
      if (AnnounceExpireCheckButton:GetChecked()) then
         -- DK --
         if (WatchPOFCheckButton:GetChecked() and ability == "Pillar of Frost") then
            msg = source .. "'s " .. ability .. " fades."
         elseif(WatchVBCheckButton:GetChecked() and ability == "Vampiric Blood") then
            msg = source .. "'s " .. ability .. " fades."
         elseif (WatchIBFCheckButton:GetChecked() and ability == "Icebound Fortitude") then
            msg = source .. "'s " .. ability .. " fades."
         elseif (WatchAMSCheckButton:GetChecked() and ability == "Anti-Magic Shell") then
            msg = source .. "'s " .. ability .. " fades."
         elseif (WatchDRWCheckButton:GetChecked() and ability == "Dancing Rune Weapon") then
            msg = source .. "'s " .. ability .. " fades."

         -- Druid --
         elseif (WatchTreeCheckButton:GetChecked() and ability == "Tree of Life") then
            msg = source .. "'s " .. ability .. " fades."
      

         -- Paladin --
         elseif (WatchDGCheckButton:GetChecked() and ability == "Divine Guardian") then
            msg = source .. "'s " .. ability .. " fades."
         elseif (WatchDPCheckButton:GetChecked() and ability == "Divine Protection") then
            msg = source .. "'s " .. ability .. " fades."
         elseif (WatchDSCheckButton:GetChecked() and ability == "Divine Shield") then
            msg = source .. "'s " .. ability .. " fades."
         elseif (WatchGotAKCheckButton:GetChecked() and ability == "Guardian of Ancient Kings") then
            msg = source .. "'s " .. ability .. " fades."
         elseif (WatchADCheckButton:GetChecked() and ability == "Ardent Defender") then
            msg = source .. "'s " .. ability .. " fades."
         elseif (WatchHoPCheckButton:GetChecked() and ability == "Hand of Protection") then
            msg = source .. "'s " .. ability .. " fades."
         elseif (WatchHSCheckButton:GetChecked() and ability == "Holy Shield") then
            msg = source .. "'s " .. ability .. " fades."
         end
      end
   end

   -- Debug
   --if (source == "Spessartine") then
      -- print (type .. ":" .. source .. " casts " .. ability)
   --end

   if (msg ~= nil) then
      msg = "[Watch4] > " .. msg
      if RaidAnnounceCheckButton:GetChecked() then
         -- print ("AnnounceToRaidCheckButton is checked")
         SendChatMessage(msg, "RAID")
      end
      if PartyAnnounceCheckButton:GetChecked() then
         SendChatMessage(msg, "PARTY")
      end
      if PrivateAnnounceCheckButton:GetChecked() then
         print (msg)
      end
      -- SendChatMessage(msg, "PARTY")
   end
end

SLASH_Watch41 = "/w4"
SLASH_Watch42 = "/Watch4"
SlashCmdList["Watch4"] = function(msg)
   ShowUIPanel(Watch4Frame)
end